#!/bin/bash

##
# Included from ./c/makefile.unx to set $PLATFORM
#
# $Id: platform.inc 70 2010-05-18 09:43:57Z svn $
#

UNAME=`uname`
echo $UNAME
#
#  Try to determine the target platform, 
#  Set it manually if needed.
#  Default is 32-bit.


if [ "$PLATFORM" = "" ]; then
	if [ "$UNAME" = "Linux" ]; then
		PLATFORM=linux32
		#PLATFORM=linux64
	elif [ "$UNAME" = "SunOS" ]; then
		PLATFORM=solaris32x86
		#PLATFORM=solaris64x86		
	elif [ "$UNAME" = "Darwin" ]; then
		PLATFORM=osx32x86 
		#PLATFORM=osx64x86
	elif [ `expr match $UNAME CYGWIN` -eq 6 ]; then
		PLATFORM=win32
		#PLATFORM=win64	
	fi	
	#
	#PLATFORM=osx32ppc 	#(platform discontinued starting v6.1)
	#PLATFORM=solaris64 	#(platform discontinued starting v6.1)
	#PLATFORM=solaris32 	#(platform discontinued starting v6.1)
	#PLATFORM=linux64ia 	#(platform discontinued starting v5.1)
	#PLATFORM=hpux32	#(platform discontinued starting v4.1)
	#PLATFORM=hpux64 	#(platform discontinued starting v4.1)	
fi


#
# Define COMMON_FLAGS as needed
#
#COMMON_FLAGS=-D_CUSTOMDEF_

#
# Set common flags, 32-bit/64-bit switches
#
# Remarks: 
#  . Compiling and linking with gcc to create 64-bit objects require -m64
#  . Compiling and linking with gcc to create 32-bit objects (on 64-bit machines) require -m32
#

COMMON_FLAGS=-m32
#COMMON_FLAGS=-m64

